<?php

namespace App\Http\Controllers;

use App\Models\Country;
use App\Models\Product;
use App\Models\ProductImage;
use App\Models\ProductIngredient;
use App\Repositories\ProductRepository;
use Request;
use Validator;



class ProductController extends Controller
{
    protected $productRepo;

    public function __construct(ProductRepository $productRepo)
    {
        $this->middleware('copyreader');
        $this->productRepo = $productRepo;
    }

    public function index()
    {
        if(Request::get('show_active_products')){
            set_user_attr('show_active_products', Request::get('show_active_products'));
        }
        if(get_user_attr('show_active_products') === "true"){
            $values = Product::where('active', true)->orderBy('pos', 'DESC')->orderBy('id', 'DESC')->get();
        }else{
            $values = Product::orderBy('pos', 'DESC')->orderBy('id', 'DESC')->get();

        }
        $data = [
            'values' => $values
        ];
        return view('admin.product.index', $data);
    }

    public function edit($id)
    {
        if($id === "new"){
            $model = new Product();
            $model->active = true;
        }else{
            $model = Product::findOrFail($id);
        }

        $country_for_prices = Country::where('own_eur', '=', true)->orWhere('currency', '=', true)->get();
        $data = [
            'product' => $model,
            'country_for_prices' => $country_for_prices,
        ];
        return view('admin.product.edit', $data);
    }

    public function store()
    {

        $data = Request::all();

        $rules = array(
            'name' => 'required',
        );
        /*if(isset($data['number']) && $data['number'] != ""){
            $rules['number'] = 'int';
        }*/
        if(isset($data['wp_number'])){
            if($data['id'] !== "new"){
                $model = Product::findOrFail($data['id']);
                $rules['wp_number'] = 'unique:products,wp_number,'.$model->id;
            }else{
                $rules['wp_number'] = 'unique:products,wp_number';

            }
        }
        $validator = Validator::make(Request::all(), $rules);

        if($data['id'] === "new"){
            $model = new Product();
        }else{
            $model = Product::findOrFail($data['id']);
        }
        $country_for_prices = Country::where('own_eur', '=', true)->orWhere('currency', '=', true)->get();

        $data = [
            'product' => $model,
            'country_for_prices' => $country_for_prices,

        ];

        if ($validator->fails()) {

            return view('admin.product.edit', $data)->withErrors($validator);

        } else {
            $product = $this->productRepo->update(Request::all());
            \Session()->flash('alert-save', true);
            return redirect(route('admin_product_edit', [$product->id]));
        }

        \Session()->flash('alert-save', '1');
        return redirect(route('admin_product_show'));
    }

    public function copy($id){
        $model = Product::findOrFail($id);
        $product = $this->productRepo->copy($model);
        \Session()->flash('alert-success', 'Eintrag kopiert');
        return redirect(route('admin_product_show'));
    }

    public function delete($id, $do = 'product', $did = null){
        if($do === 'product'){
            $model = Product::findOrFail($id);
            $model->delete();
            \Session()->flash('alert-success', 'Eintrag gelöscht');
            return redirect(route('admin_product_show'));
        }

        if($do === 'ingredient'){
            $model = Product::findOrFail($id);
            $ProductIngredient = ProductIngredient::where('ingredient_id', $did)->where('product_id', $model->id)->first();
            if($ProductIngredient){
                $ProductIngredient->delete();
                \Session()->flash('alert-success', 'Eintrag gelöscht');
                return redirect(route('admin_product_edit', [$model->id]));
            }

        }

    }

    // Upload FILE  -----------------------------------------------------------------------------------------------------------------------
    public function imageUpload(){

        if(Request::has('product_id')){
            $product = Product::findOrFail(Request::get('product_id'));
            return \App\Services\ProductImage::imageUpload('product', $product, Request::get('upload_type'));
        }
    
    }

    public function imageDelete($product_image_id, $product_id){
        $product = Product::findOrFail($product_id);
        return \App\Services\ProductImage::imageDelete('product', $product, $product_image_id);

    }

    public function imageAttribute($product_id, $attr, $val = false){

        if(is_numeric($val) && $val < 0){
            $val = 0;
        }

        $product_image = ProductImage::findOrFail($product_id);

        $product_image->{$attr} = $val;
        $product_image->save();

        \Session()->flash('alert-success', "Wert gespeichert");
        return redirect()->back();

    }

}